package ru.dbotthepony.kstarbound.defs

import ru.dbotthepony.kstarbound.json.builder.JsonFactory

@JsonFactory
data class PerlinNoiseParameters(
	val type: Type = Type.PERLIN,
	val seed: Long? = null,
	val scale: Int = 512,
	val octaves: Int = 1,
	val gain: Double = 2.0,
	val offset: Double = 1.0,
	val beta: Double = 1.0,
	val alpha: Double = 2.0,
	val frequency: Double = 1.0,
	val amplitude: Double = 1.0,
	val bias: Double = 0.0,
) {
	init {
		require(scale >= 16) { "Too little perlin noise scale" }
	}

	enum class Type {
		PERLIN,
		BILLOW,
		RIDGED_MULTI;
	}
}
